2010年以前,互联网公司最常用的Web服务组合就是LAMP(即Linux、Apache、MySQL、PHP),近几年随着Nginx
Web服务的逐渐流行,又出现了新的Web服务环境组合--LNMP or
LEMP。LNMP即Linux、Nginx、MySQL、PHP。LEMP中的E表示的也是Nginx,它取自Nginx名字的发音engine
x.目前LNMP已经逐渐成为国内大中型互联网公司网站的主流组合环境。

LNMP环境基本请求顺序

当LNMP组合工作时,首先用户通过浏览器输入域名请求Nginx
Web服务,如果请求是静态资源,则由Nginx解析返回给用户;如果是动态请求(.php)结尾,那么Nginx就会把它通过FastCGI接口(生产常用方法)发送给PHP引擎服务(FastCGI进程php-fpm)进行解析,如果这个动态请求要读取数据库数据,那么PHP就会继续向后请求MySQL数据库,以读取需要的数据,并最终通过Nginx服务把获取的数据返回给用户。

图片 1

2017/5/11截图。上图来自。2014年Apache与Ngnix份额分别为58.5%、23.3%

 

背景

上个星期,Web应用开发老师要检查作业。要求把自己做的网页放到云上去。好吧,于是我去注册了腾讯云。反正我可以试用一个月哈哈……

图片 2

接着,我在笔记本用CRT连接到远程主机!!
当时连接成功时,我心里那个激动啊!!!

图片 3

so, 然后呢??
我要的是把html代码放到云服务器上,接着在我本地电脑输入url就可以访问。这显然没实现我的需求。后来,上实验课问了下同学,说安装Apache就可以了(最多问下Apache是什么,难道我还问Apache怎么安装?这会显得我没脑子……)。好吧,不得不承认我Linux还没入门……

 

现在,我电脑虚拟机的Linux系统已经装了Nginx,
MySQL,
PHP。下图是我安装完Nginx后,修改nginx.conf配置文件,index.html文件,及电脑本地的hosts文件后,在本地电脑输入自定义的域名www.chengliang.com。我能访问到远程Linux系统的html文件(页面)。牛!!

图片 4

 

编译安装PHP出现的问题

OK,
以上,都不是本文的重点。

昨晚在编译安装PHP时出错一些问题,搞得我很晚才睡……

解压PHP安装包

tar zxf php-5.5.56

配置pHP软件.
下面这代码我敲得想吐了……具体参数意义,参见

./configure --prefix=/application/php5.6.30 --with-mysql=/application/mysql --with-iconv-dir=/usr/local/libiconv --with-freetype-dir --with-jpeg-dir --with-png-dir --with-zlib --with-libxml-dir=/usr --enable-xml --disable-rpath --enable-safe-mode --enable-bcmath --enable-shmop --enable-sysvsem --enable-inline-optimization --with-curl --with-curlwrappers --enable-mbregex --enable-fpm --enable-mbstring --with-mcrypt --with-gd --enable-gd-native-ttf --with-openssl --with-mhash --enable-pcntl --enable-sockets --with-xmlrpc --enable-zip --enable-soap --enable-short-tags --enable-zend-multibyte --enable-static --with-xsl --with-fpm-user=nginx with-fpm-group=nginx --enable-ftp

如果你想在Linux上装PHP,千万别直接复制上面的代码。上面代码包含mysql路径,libiconv库的路径等,每台机器路径都可能不同,有些包也可能还没下载。如果直接复制进行编译的话,基本都会出错,哈哈

编译PHP软件./configure,结束后正确输出提示,如下图:

图片 5

 

当然,刚开始我没成功,出现下图所示的error.

configure: error: Don't know how to define struct flock on this system, set --enable-opcache=no

图片 6

 

解决

我上网查了很多很多博客。大部分解决方法是:

编辑 /etc/ld.so.conf 加入/usr/local/lib,在执行ldconfig,使ld.so.conf文件生效。

but,还是没解决我的问题!!fuck

差不多要放弃时,看到这博文章,
give me hope.

网上的解决思路没错,就是需要关联到某个so的文件。但是至于具体需要那个.so文件,在什么位置却并没有细究,有点儿“一概论”的意思。我的/usr/local/lib里面实际上是空的。

图片 7

后来搜了很多资料发现,这个报错需要的大概是libmysqlclient.so。我的libmysqlclient.so文件在哪呢?我也不知道。不过libmysqlclient.so一看就和mysql有不可告人的关系,于是我到mysql下找找看。

图片 8

终于,找到了,libmysqlclient.so在/application/mysql/lib路径下。接下来按原先的步骤执行:

编辑/etc/ld.so.conf加入这个路径,ldconfig。再重新./configure,顺利通过。。。

这里给大家分享一下,遇到同样报错的朋友要根据自己的环境设置,不能一味照抄网上的命令。

 

虽然重新翻译PHP成功,但是出现下图的WARNING

configure: WARNING: unrecognized options: --enable-safe-mode, --enable-curlwrappers, --enable-zend-multibyte

图片 9

警告原因:

之前 php-5.3.x 编译时加了
–enable-safe-mode –enable-discard-path –enable-fastcgi
–enable-force-cgi-redirect选项,但是这个选项没必要,且会带来许多的麻烦,详解可以
google 一下,php-5.4.x 已经去掉了该选项,编译时可以 #./configure –help | grep
“safe-mode” 查看一下,没有信息输出,表示已经不支持!

图片 10

我对–enable-safe-mode,
–enable-curlwrappers,
–enable-zend-multibyte 这三个引起警告的选项都过滤一下。发现都没有信息输出。so,
php5.6.30应该是已经不支持这三个选项了!